<!-- Copyright (C) Perinet -->
<!DOCTYPE html>
<html>

<head>
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta http-equiv="content-type" content="text/html; charset=utf-8" />

    <title>Power Meter</title>

    <link rel="stylesheet" type="text/css" href="static/css/base.css" />
    <link rel="stylesheet" type="text/css" href="static/css/framing.css" />
    <link rel="stylesheet" type="text/css" href="static/css/home.css" />
    <link rel="stylesheet" type="text/css" href="static/css/style.css" />
    <link rel="stylesheet" type="text/css" href="static/css/switches.css" />
    <link rel="stylesheet" type="text/css" href="static/css/help-tip.css" />
    <link rel="stylesheet" type="text/css" href="static/css/keyframes.css" />
    <link rel="stylesheet" type="text/css" href="static/css/information-text.css" />
    <link rel=icon type="image/png" href=/favicon.ico>
    <script type="text/javaScript" src="static/js/jquery-3.6.0.min.js"></script>
    <script type="text/javaScript" src="static/js/cert_decoder.js"></script>
    <script type="text/javaScript" src="static/js/security.js"></script>
    <script type="text/javaScript">

        var cached_brokers = [];
        var cached_modbus_servers = [];

        // Initialize index.html -> called@onload
        function init() {
            init_security(true);
            get_mbap_servers();
            get_brokers();
            get_mbap_sample();
            get_rest("/node/config", get_config_callback);
            get_rest("/mqtt_client/config", get_mqtt_config_callback);
            get_rest("/powermeter-sdm630/config", get_modbus_config_callback);
            setInterval(get_brokers, 2500);
            setInterval(get_mbap_servers, 2500);
            setInterval(get_mbap_sample, 3000);
        }

        function get_mbap_sample() {
            get_rest("/powermeter-sdm630/sample", get_modbus_sample_callback);
        }

        function get_mbap_servers() {
            get_rest("/dns-sd/discovered-services/_mbap._tcp", get_mbap_servers_callback);
            // get_rest("/dns-sd/discovered-services/_mbap-s._tcp", get_mbap_servers_callback);
        }

        function get_mbap_servers_callback(data) {
            var modbus_servers = JSON.parse(data);
            if(modbus_servers.length == 0) {
                return;
            }
            for (var i = 0; i < modbus_servers.length; i++) {
                const modbus_server = modbus_servers[i];
                if(!cached_modbus_servers.includes(modbus_server)) {
                    cached_modbus_servers.push(modbus_server);
                    var option_name = document.createElement('option');
                    option_name.value = modbus_server.hostname;
                    document.getElementById("modbus_server_name").appendChild(option_name);

                    var option_port = document.createElement('option');
                    option_port.value = modbus_server.port;

                    // Prevent adding a port number multiple times
                    var ports = document.getElementById("modbus_server_port");
                    if(ports.childElementCount == 0) {
                        document.getElementById("modbus_server_port").appendChild(option_port);
                    } else {
                        for(var i = 0; i < ports.childElementCount; i++) {
                            if(parseInt(ports.childNodes[i].value, 10) == modbus_server.port) {
                                continue;
                            } else {
                                document.getElementById("modbus_server_port").appendChild(option_port);
                            }
                        }
                    }
                }
            }
        }

        function get_brokers() {
            get_rest("/dns-sd/discovered-services/_mqtt._tcp", get_brokers_callback, function(){});
            get_rest("/dns-sd/discovered-services/_secure-mqtt._tcp", get_brokers_callback, function(){});
        }

        function get_brokers_callback(data) {
            var brokers = JSON.parse(data);
            if(brokers.length == 0) {
                return;
            }

            for (var i = 0; i < brokers.length; i++) {
                const broker = brokers[i];
                if(!cached_brokers.includes(broker)) {
                    cached_brokers.push(broker);
                    var option = document.createElement('option');
                    option.value = broker.hostname;
                    document.getElementById("mqtt_broker_name").appendChild(option);
                }
            }
        }

        function get_rest(url, success_callback, error_callback) {
            var http = new XMLHttpRequest();
            http.open( "GET", url);
            http.send();
            http.onreadystatechange = function() {
                if(this.readyState == 4) {
                    if(this.status == 200) {
                        success_callback(http.responseText);
                    }
                    else {
                        if(error_callback === undefined) {
                            alert(http.responseText);
                        }
                        else {
                            error_callback();
                        }
                    }
                }
            }
        }

        function patch_json_rest(url, payload_json, callback) {
            var http = new XMLHttpRequest();
            http.open("PATCH", url);
            http.setRequestHeader("Content-Type", "application/json;charset=UTF-8");
            http.send(JSON.stringify(payload_json));
            http.onreadystatechange = function(){
                if(this.readyState == 4) {
                    callback(http);
                }
            }
        }

        function get_config_callback(data) {
            var config = JSON.parse(data);
            document.getElementById("element_name").value = config["element_name"];
            document.getElementById("application_name").value = config["application_name"];
        }

        function get_modbus_config_callback(data) {
            var config = JSON.parse(data);
            document.getElementById("modbus_server_name_value").value =config["hostname"];
            document.getElementById("modbus_slave_address").value =config["rtu_address"];
            document.getElementById("period_seconds").value = config["sample_rate"];
        }

        function get_mqtt_config_callback(data) {
            var config = JSON.parse(data);
            document.getElementById("mqtt_broker_name_value").value =config["broker_uri"];
        }

        function get_modbus_sample_callback(data) {
            var sample = JSON.parse(data);

            document.getElementById("L1Current").value = parseFloat(sample["l1_current"].value).toFixed(3) + sample["l1_current"].unit;
            document.getElementById("L2Current").value = parseFloat(sample["l2_current"].value).toFixed(3) + sample["l2_current"].unit;
            document.getElementById("L3Current").value = parseFloat(sample["l3_current"].value).toFixed(3) + sample["l3_current"].unit;

            document.getElementById("L1Voltage").value = parseFloat(sample["l1_voltage"].value).toFixed(3) + sample["l1_voltage"].unit;
            document.getElementById("L2Voltage").value = parseFloat(sample["l2_voltage"].value).toFixed(3) + sample["l2_voltage"].unit;
            document.getElementById("L3Voltage").value = parseFloat(sample["l3_voltage"].value).toFixed(3) + sample["l3_voltage"].unit;

            document.getElementById("L1PowerW").value = parseFloat(sample["l1_power"].value).toFixed(3) + sample["l1_power"].unit;
            document.getElementById("L2PowerW").value = parseFloat(sample["l2_power"].value).toFixed(3) + sample["l2_power"].unit;
            document.getElementById("L3PowerW").value = parseFloat(sample["l3_power"].value).toFixed(3) + sample["l3_power"].unit;

            document.getElementById("L1PhaseAngle").value = parseFloat(sample["l1_phase_angle"].value).toFixed(3) + sample["l1_phase_angle"].unit;
            document.getElementById("L2PhaseAngle").value = parseFloat(sample["l2_phase_angle"].value).toFixed(3) + sample["l2_phase_angle"].unit;
            document.getElementById("L3PhaseAngle").value = parseFloat(sample["l3_phase_angle"].value).toFixed(3) + sample["l3_phase_angle"].unit;

            document.getElementById("total_power_import").value = parseFloat(sample["total_import"].value).toFixed(3) + sample["total_import"].unit;
            document.getElementById("total_power_export").value = parseFloat(sample["total_export"].value).toFixed(3) + sample["total_export"].unit;

            var date = new Date();
            document.getElementById("lastUpdate").innerHTML = "Last Update: " + date;
        }

        function configure() {
            var config = {};
            config["element_name"] = document.getElementById("element_name").value;
            config["application_name"] = document.getElementById("application_name").value;
            patch_json_rest("/node/config", config, function(http){check_error_patch(http, "Super");});
        }

        function configure_modbus() {
            var config = {};
            config["hostname"] = document.getElementById("modbus_server_name_value").value;
            config["rtu_address"] = parseInt(document.getElementById("modbus_slave_address").value, 10);
            config["sample_rate"] = +(document.getElementById("period_seconds").value);
            patch_json_rest("/powermeter-sdm630/config", config, function(http){check_error_patch(http, "Super");});
        }

        function configure_broker() {
            var config = {};
            config["broker_uri"] = document.getElementById("mqtt_broker_name_value").value;
            patch_json_rest("/mqtt_client/config", config, function(http){check_error_patch(http, "Super");});
        }

        </script>
</head>

<body onload=init()>
    <div class="headercontainer">
        <!--Metanav-->
        <div class="meta">
            <div class="left" style="line-height: 24px;font-weight: bold;">Eastron SDM-630 power meter</div>
            <div class="middle"></div>
            <div class="right"><span></span></div>
        </div>
        <!--END Metanav-->

        <div class="header" id="header_cnt">
            <div class="headerlogo"><img src="static/images/logo_perinet.png" width="258" height="94" alt="" /></div>
        </div>
    </div>

    <!--Content-->
    <div id="content">
        <div id="inner_content">
            <div class="contentinput" style="padding-bottom: 50px;">
                <div class="inputitem" style="margin-bottom: 100px;">
                    <section>
                        <h2>Description</h2>
                        The <span style="font-weight:bold;">Application power meter</span> collects data of
                        Eastron SDM630 modbus power meter and provides them in format readable by the dashboard container.


                        <div class="contentline_single gap10_20" style="margin-top:50px"></div>
                        <h2>Current Values</h2>
                        <table>
                            <tr>
                                <td colspan="2" class="left"></td>
                            </tr>
                            <tr>
                                <th></th>
                                <th style="text-align:center">Total Power</th>
                            </tr>
                            <tr>
                                <td colspan="2" class="left"></td>
                            </tr>
                            <tr>
                                <th>Import</th>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 kWh" id="total_power_import" readonly/>
                                </td>
                            </tr>
                            <tr>
                                <th>Export</th>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 kWh" id="total_power_export" readonly/>
                                </td>
                            </tr>
                            <tr>
                                <td colspan="2" class="left"></td>
                            </tr>
                            <tr>
                                <th></th>
                                <th style="text-align:center">Voltage</th>
                                <th style="text-align:center">Current</th>
                                <th style="text-align:center">Power</th>
                                <th style="text-align:center">Phase angle deviation</th>
                            </tr>
                            <tr>
                                <td colspan="2" class="left"></td>
                            </tr>
                            <tr>
                                <th>L1</th>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 V" id="L1Voltage" readonly/>
                                </td>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 A" id="L1Current" readonly/>
                                </td>
                                <td >
                                    <input style="text-align:right;margin-left:50px;width:90px;" type="text" placeholder="0.0 W" id="L1PowerW" readonly/>
                                </td>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 °" id="L1PhaseAngle" readonly/>
                                </td>
                            </tr>
                            <tr>
                                <th>L2</th>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 V" id="L2Voltage" readonly/>
                                </td>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 A" id="L2Current" readonly/>
                                </td>
                                <td >
                                    <input style="text-align:right;margin-left:50px;width:90px;" type="text" placeholder="0.0 W" id="L2PowerW" readonly/>
                                </td>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 °" id="L2PhaseAngle" readonly/>
                                </td>
                            </tr>
                            <tr>
                                <th>L3</th>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 V" id="L3Voltage" readonly/>
                                </td>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 A" id="L3Current" readonly/>
                                </td>
                                <td >
                                    <input style="text-align:right;margin-left:50px;width:90px;" type="text" placeholder="0.0 W" id="L3PowerW" readonly/>
                                </td>
                                <td>
                                    <input style="text-align:right;margin-left:55px;width:90px;" type="text" placeholder="0.0 °" id="L3PhaseAngle" readonly/>
                                </td>
                            </tr>
                        </table>
                        <div class="informationText-box">
                            <p class="informationText" id="lastUpdate">Last Update: </p>
                        </div>

                        <div class="contentline_single gap10_20" style="margin-top:50px"></div>
                        <div class="contentinput" style="margin-bottom: 20px;">
                            <h2>Modbus TCP configuration</h2>
                            <table style="padding-left:60px">
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>

                                <tr>
                                    <td class="left">Modbus Tcp server:</td>
                                    <td class="input">
                                        <div style="position: relative">
                                            <div class="help-tip"></div>
                                            <label>
                                                <p id="otp_tip" class="otp_tip">Modbus Tcp server is the hostname of the
                                                    Modbus TCP to RTU bridge container.
                                                </p>
                                            </label>
                                        </div>
                                        <input style="margin-left:55px;width:497px;" type="text"
                                            title="<url>" placeholder="modbus-example.local"
                                            id="modbus_server_name_value" list="modbus_server_name">
                                        <datalist id="modbus_server_name"></datalist>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="left">Modbus slave address:</td>
                                    <td class="input">
                                        <div style="position: relative">
                                            <div class="help-tip"></div>
                                            <label>
                                                <p class="otp_tip">Modbus slave address is the address of the
                                                    Eastron SDM630 power meter you can connect to on the Modbus-RTU. Its
                                                    default address is "1". It is possible to change the modbus address
                                                    directly at the device. If done it is needed to change the address
                                                    here too. Please use decimal format for entering addresses.
                                                </p>
                                            </label>
                                        </div>
                                        <input style="margin-left:55px;width:497px;" type="text"
                                            title="slave address" placeholder="slave address"
                                            id="modbus_slave_address"></input>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="left">Sample period (seconds):</td>
                                    <td class="input">
                                        <div style="position: relative">
                                            <div class="help-tip"></div>
                                            <label>
                                                <p class="otp_tip">Sample period [s] is the time interval between
                                                    two consecutive measurements. Minimum resolution is <i>0.1 s</i>.
                                                    A value of <i>0</i> switches the measurement off.
                                                    Due to the limitation of mbus data rate and for this application
                                                    the minimum sample rate should be set to <i>2</i>.
                                                </p>
                                            </label>
                                        </div>
                                        <input style="margin-left:55px;width:315px;" type="number" min="0.1"
                                            step="0.1" id="period_seconds"/>
                                        <input type="submit" class="submit_bt enabled short nextto" enabled
                                            onclick="configure_modbus()" value="Configure"/>
                                    </td>
                                </tr>

                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                            </table>
                        </div>


                        <div class="contentline_single gap10_20" style="margin-top:50px"></div>
                        <div class="contentinput" style="margin-bottom: 20px;">
                            <h2>Application name and Element name</h2>
                            <table style="padding-left:60px">
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>

                                <tr>
                                    <td class="left">Application name:</td>
                                    <td class="input">
                                        <input style="margin-left:55px;width:497px;" type="text" id="application_name"
                                            placeholder="application_name"></input>
                                    </td>
                                </tr>
                                <tr>
                                    <td class="left">Element name:</td>
                                    <td class="input">
                                        <input style="margin-left:55px;width:315px;" type="text" id="element_name"
                                            placeholder="element_name"></input>
                                        <input type="submit" class="submit_bt enabled short nextto" enabled
                                            onclick="configure()" value="Configure"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                            </table>
                        </div>


                        <div class="contentline_single gap10_20" style="margin-top:50px"></div>
                        <div class="contentinput" style="margin-bottom: 20px;">
                            <h2>MQTT broker</h2>
                            <table style="padding-left:60px">
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                                <tr>
                                    <td class="left">MQTT broker:</td>
                                    <td class="input">
                                        <input style="margin-left:55px;width:315px;" type="text" pattern="mqtt[s]*://.*"
                                            title="<url>" placeholder="mqtt.example.com"
                                            id="mqtt_broker_name_value" list="mqtt_broker_name">
                                        <datalist id="mqtt_broker_name"></datalist>
                                        <input type="submit" class="submit_bt enabled short nextto" enabled
                                            onclick="configure_broker()" value="Configure"/>
                                    </td>
                                </tr>
                                <tr>
                                    <td colspan="2" class="left"></td>
                                </tr>
                            </table>
                        </div>

                        <div class="contentline_single gap10_20" style="margin-top:50px"></div>
                        <div class="contentinput" style="margin-bottom: 20px;">
                            <h2>Security configuration</h2>
                            <table id="security_table" align="left">
                            </table>
                        </div>
                    </section>
                </div>
            </div>


            <!--Footer-->
            <br>
            <div class="footer">
                <div>
                    <div style="float:left;width:140px;text-align:left;font-weight:bold;">periMICA</div>
                    <div style="float:left;width:780px;text-align:right;"><span></span></div>
                </div>
            </div>

        </div>
    </div>

</body>

</html>
